/* TurboC v1.5 & v2.0 Header File */
/* This is PROLOST.H -- and this is an include file to cover some of the
   different types of list structures that are found in Turbo Prolog
   version 2.0
*/


#define is_element 1  /* This means the node is an element */
#define is_null 2     /* This means that this is the termiatiing */

/* Union of all types */
typedef union AllTypes {
   char Character;  /* Either a character */
   int  Integer;
   char *String;
   char *Symbol;
} AllTypes;

/* This is the basic definition of a functor */
typedef struct Functor {
   unsigned char FuncNum;
   AllTypes *FuncValue;
} Functor;

/* This is a list of integers ---  IntList */
typedef struct IntList {
  unsigned char   NodeType;       /* Type of node (element or nul) */
  int    IntValue;       /* The value of the integer there */
  struct IntList *Next;  /* Pointer to next element */
} IntList;

/* This is a list of reals    ---  RealList  */
typedef struct RealList {
  unsigned char   NodeType;
  double RealValue;
  struct RealList *Next;
} RealList;


/* This is a list of strings  ----  StrList  */
typedef struct StrList {
  unsigned char   NodeType;
  char   *Str;
  struct StrList *Next;
} StrList;


/* This is a list of of symbols -- SymList  */
typedef struct SymList {
  unsigned char   NodeType;
  char   *Sym;
  struct SymList *Next;
} SymList;

/* A list of compund objects */
typedef struct Compound {
  unsigned char NodeType;  /* 1 = valid, 2 = nope */
  Functor *Fn;
  struct Compound *Next;
} Compound;
